vRP = Proxy.getInterface("vRP")


local assestsReady = false
local diceScales = vector2(0.0, 0.0)

local dc = {"dice_1", "dice_2x", "dice_3", "ddx_4yy", "ddx_5xz", "dice_6"}

Citizen.CreateThread(function()
	local txd = CreateRuntimeTxd("ug_dices")
	CreateRuntimeTextureFromImage(txd, dc[1], "assests/dices/1.png")
	CreateRuntimeTextureFromImage(txd, dc[2], "assests/dices/2.png")
	CreateRuntimeTextureFromImage(txd, dc[3], "assests/dices/3.png")
	CreateRuntimeTextureFromImage(txd, dc[4], "assests/dices/4.png")
	CreateRuntimeTextureFromImage(txd, dc[5], "assests/dices/5.png")
	CreateRuntimeTextureFromImage(txd, dc[6], "assests/dices/6.png")
	local rx, ry = GetActiveScreenResolution()
	local textureRes = GetTextureResolution("ug_dices", dc[1])
	diceScales = vector2(textureRes.x / rx, textureRes.y / ry) / 12
	assestsReady = true
end)

local fontsLoaded = false
local fontId
Citizen.CreateThread(function()
  Citizen.Wait(1000)
  RegisterFontFile('wmk')
  fontId = RegisterFontId('Freedom Font')
  fontsLoaded = true
end)

Citizen.CreateThread(function()
  local dices = CreateRuntimeTxd("dices")
  CreateRuntimeTextureFromImage(dices, "dices", "img/dices.png")
end)

local inGame = false
local hasJustRoll = 0
local hasWinFeedback = 0
local winFeedback = nil
local rolling = false
local theBet = 0

local function drawDice(x, y, nr)
	DrawSprite("ug_dices", dc[nr], x, y, diceScales, 0.0, 255, 255, 255, 255)
	DrawSprite("dices","dices",0.48,0.35,0.25,0.40,0.0,255,255,255,255)
end

local function drawText(text, x, y, scale, r, g, b)
	SetTextFont(fontId)
	SetTextCentre(1)
	SetTextProportional(0)
	SetTextScale(scale, scale)
	SetTextDropShadow(30, 5, 5, 5, 255)
	SetTextEntry("STRING")
	SetTextColour(r, g, b, 255)
	AddTextComponentString(text)
	DrawText(x, y)
end

local function drawButton(x, y, width, height, text, hr, hg, rb, cb)

    local cursorX = GetDisabledControlNormal(0, 239)
    local cursorY = GetDisabledControlNormal(0, 240)

    local hover = false
    if x - (width/2) < cursorX and x + (width/2) > cursorX then
    	if y - (height/2) < cursorY and y + (height/2) > cursorY then
    		hover = true
    	end
    end

    if hover then
    	SetMouseCursorSprite(5)
    	drawText(text, x, y-(height/2), 0.6, hr, hg, rb)
		DrawRect(x, y, width, height, 255, 255, 255, 200)
		if IsDisabledControlJustPressed(0, 24) then
			cb()
		end
    else
	    drawText(text, x, y-(height/2), 0.6, 80, 80, 80)
		DrawRect(x, y, width, height, 255, 255, 255, 100)
	end
end

local dcs = {}
local diceNumbers = {math.random(1, 6), math.random(1, 6), math.random(1, 6), math.random(1, 6)}

RegisterNetEvent("ples-barbut:getResults")
AddEventHandler("ples-barbut:getResults", function(results, withFakeRolls,id)
	dcs = results
	if withFakeRolls then
		hasJustRoll = 0
		Citizen.CreateThread(function()
			rolling = true
			local untilTime = GetGameTimer() + 4000
			print(GetGameTimer(),untilTime)
			while GetGameTimer() < untilTime do
				for x=1, 4 do
					Citizen.Wait(10)
					diceNumbers[x] = math.random(1, 6)
				end

			end

			hasJustRoll = GetGameTimer() + 3500
			Citizen.Wait(1000)
			rolling = false
			
		end)
	else
		rolling = true
		for x=1, 4 do
			Citizen.Wait(20)
			diceNumbers[x] = dcs[x]
		end
		Citizen.Wait(1000)
		rolling = false

	end
end)

local function startRolling(id)
	TriggerServerEvent("ples-barbut:startRolling",id)
	hasJustRoll = 0

	Citizen.CreateThread(function()
		rolling = true
		local untilTime = GetGameTimer() + 4000
		print(GetGameTimer(),untilTime)
		while GetGameTimer() < untilTime do
			for x=1, 4 do
				Citizen.Wait(10)
				diceNumbers[x] = math.random(1, 6)
			end

		end

		hasJustRoll = GetGameTimer() + 3500
		TriggerServerEvent("ples-barbut:doneRolls",id,diceNumbers)
		Citizen.Wait(1000)
		rolling = false
		
	end)
end

RegisterNetEvent("ples-barbut:cancelGame")
AddEventHandler("ples-barbut:cancelGame", function()
	inGame = false
end)

RegisterNetEvent("ples-barbut:getWinFeedback")
AddEventHandler("ples-barbut:getWinFeedback", function(text)
	hasWinFeedback = GetGameTimer() + 3500
	winFeedback = text
end)

RegisterNetEvent("ples-barbut:startChangingBet")
AddEventHandler("ples-barbut:startChangingBet", function()
	rolling = true
end)

RegisterNetEvent("ples-barbut:havemoney")
AddEventHandler("ples-barbut:havemoney", function(id)
	startRolling(id)
end)

RegisterNetEvent("ples-barbut:setNewBet")
AddEventHandler("ples-barbut:setNewBet", function(newBet)
	theBet = newBet
	Citizen.Wait(500)
	rolling = false
end)

RegisterNetEvent("ples-barbut:joinGame")
AddEventHandler("ples-barbut:joinGame", function(gameId, gameData)
	while not HasStreamedTextureDictLoaded("ug_dices") do
		RequestStreamedTextureDict("ug_dices", false)
		Citizen.Wait(100)
	end

	inGame = true
	theBet = gameData.bet

	local effect = "MenuMGHeist"
	StartScreenEffect(effect.."In", 0, true)

	while inGame do

		SetMouseCursorActiveThisFrame()
		SetMouseCursorSprite(1)
		for i=0, 31 do
	        DisableAllControlActions(i)
	    end
	    EnableControlAction(0, 249, true) -- voicechat
	    EnableControlAction(0, 246, true) -- voicechat range
	    EnableControlAction(3, 177, true) -- backspace / esc
	    EnableControlAction(0, 11, true) -- Page down
	    EnableControlAction(0, 167, true) -- F6

		-- Player 1
		drawText(gameData.name, 0.175, 0.52, 0.4, 255, 255, 255)
		drawDice(0.15, 0.60, diceNumbers[1])
		drawDice(0.20, 0.60, diceNumbers[2])
		if GetGameTimer() < hasJustRoll then
			drawText(diceNumbers[1] + diceNumbers[2], 0.175, 0.65, 0.8, 236, 44, 44)
		end
		
		-- Player 2
		drawText(gameData.ename, 0.825, 0.52, 0.4, 255, 255, 255)
		drawDice(0.80, 0.60, diceNumbers[3])
		drawDice(0.85, 0.60, diceNumbers[4])
		if GetGameTimer() < hasJustRoll then
			drawText(diceNumbers[3] + diceNumbers[4], 0.825, 0.65, 0.8, 236, 44, 44)
		end

		drawText("MIZA: ~HUD_COLOUR_NET_PLAYER13~"..theBet.." LEI", 0.5, 0.8, 0.5, 236, 44, 44)

		if GetGameTimer() < hasWinFeedback then
			drawText(winFeedback, 0.5, 0.6, 0.8, 255, 255, 255)
		end

		if not rolling then
			drawButton(0.45, 0.77, 0.1, 0.05, "Joaca", 236, 44, 44,function()
				--startRolling(gameId)
				TriggerServerEvent("ples-barbut:trystartrolling",gameId)
			end)
			drawButton(0.55, 0.77, 0.1, 0.05, "Renunta", 236, 44, 44, function()
				inGame = false
				TriggerServerEvent("ples-barbut:abortGame",true,gameId)
			end)
		end

		Citizen.Wait(1)
	end

	StopScreenEffect(effect.."In")
	StartScreenEffect(effect.."Out", 800, false)
end)

local enemyName = nil

RegisterNetEvent("ples-barbut:setEnemy")
AddEventHandler("ples-barbut:setEnemy", function(name)
	enemyName = name
end)

RegisterNetEvent("ples-barbut:createGame")
AddEventHandler("ples-barbut:createGame", function(gameData)
	while not HasStreamedTextureDictLoaded("ug_dices") do
		RequestStreamedTextureDict("ug_dices", false)
		Citizen.Wait(100)
	end

	inGame = true
	enemyName = nil
	theBet = gameData.bet

	local effect = "MenuMGHeist"
	StartScreenEffect(effect.."In", 0, true)

	while inGame do

		SetMouseCursorActiveThisFrame()
		SetMouseCursorSprite(1)
		for i=0, 31 do
	        DisableAllControlActions(i)
	    end
	    EnableControlAction(0, 249, true) -- voicechat
	    EnableControlAction(0, 246, true) -- voicechat range
	    EnableControlAction(3, 177, true) -- backspace / esc
	    EnableControlAction(0, 11, true) -- Page down
	    EnableControlAction(0, 167, true) -- F6

		-- Player 1
		if enemyName then
			drawText(enemyName, 0.175, 0.52, 0.4, 255, 255, 255)
			drawDice(0.15, 0.60, diceNumbers[1])
			drawDice(0.20, 0.60, diceNumbers[2])
			if GetGameTimer() < hasJustRoll then
				drawText(diceNumbers[1] + diceNumbers[2], 0.175, 0.65, 0.8, 236, 44, 44)
			end
		else
			drawText("Asteapta Jucator...", 0.175, 0.56, 0.4, 101, 173, 202)
		end
		-- Player 2
		drawText(gameData.ename, 0.825, 0.52, 0.4, 255, 255, 255)
		drawDice(0.80, 0.60, diceNumbers[3])
		drawDice(0.85, 0.60, diceNumbers[4])
		if GetGameTimer() < hasJustRoll then
			drawText(diceNumbers[3] + diceNumbers[4], 0.825, 0.65, 0.8, 236, 44, 44)
		end

		drawText("MIZA: ~HUD_COLOUR_NET_PLAYER13~"..theBet.." LEI", 0.48, 0.85, 0.5, 255, 255, 255)

		if GetGameTimer() < hasWinFeedback then
			drawText(winFeedback, 0.5, 0.6, 0.8, 255, 255, 255)
		end

		if not rolling then
			drawButton(0.48, 0.80, 0.1, 0.05, "Renunta", 101, 173, 202, function()
				inGame = false
				TriggerServerEvent("ples-barbut:abortGame")
			end)
		end

		Citizen.Wait(1)
	end

	StopScreenEffect(effect.."In")
	StartScreenEffect(effect.."Out", 800, false)
end)

local function DrawText3D(x,y,z, text, scl) 

    local onScreen,_x,_y=World3dToScreen2d(x,y,z)
    local px,py,pz=table.unpack(GetGameplayCamCoords())
    local dist = GetDistanceBetweenCoords(px,py,pz, x,y,z, 1)
 
    local scale = (1/dist)*scl
    local fov = (1/GetGameplayCamFov())*100
    local scale = scale*fov
   
    if onScreen then
        SetTextScale(0.0*scale, 1.1*scale)
        SetTextFont(fontId)
        SetTextProportional(1)
        SetTextColour(255, 0, 0, 0.8)
        SetTextDropshadow(0, 0, 0, 0, 255)
        SetTextEdge(2, 0, 0, 0, 150)
        SetTextDropShadow()
        SetTextOutline()
        SetTextEntry("STRING")
        SetTextCentre(1)
        AddTextComponentString(text)
        DrawText(_x,_y)
    end
end

local barbutLocations = {}

RegisterNetEvent("ples-barbut:getNewPosition")
AddEventHandler("ples-barbut:getNewPosition", function(posIndex, posData)
	--print("xxxxxxxx "..posIndex,posData[1])
	barbutLocations[posIndex] = posData
end)

RegisterNetEvent("ples-barbut:deletePosition")
AddEventHandler("ples-barbut:deletePosition", function(posIndex)
	if barbutLocations[posIndex] ~= nil then
		barbutLocations[posIndex] = nil
	end
end)

Citizen.CreateThread(function()
	local nearGames = {}
	local ped = GetPlayerPed(-1)

	Citizen.CreateThread(function()
		while true do
			Citizen.Wait(1)
			if inGame then
				Citizen.Wait(5000)
			else
				for i, v in pairs(nearGames) do
					if v then
						DrawText3D(v[1], v[2], v[3]+1.01, "~w~/joinbarbut~p~ "..i, 0.5)
						DrawText3D(v[1], v[2], v[3]+0.95, "[BET: ~p~$"..v[4].."~w~]", 0.5)
					end
				end
			end
		end
	end)

	while true do
		Citizen.Wait(1500)
		nearGames = {}
		if inGame then
			Citizen.Wait(5000)
		else
			ped = GetPlayerPed(-1)
			if not IsPedSittingInAnyVehicle(ped) then 
				local pedCoords = GetEntityCoords(ped)
				for indx, data in pairs(barbutLocations) do
					local dst = GetDistanceBetweenCoords(pedCoords, data[1], data[2], data[3], false)
					if dst < 10 then
						nearGames[indx] = data
					end
				end
			end
		end
	end

end)